function gw = bilineal(gz,T)

% Funcin para pasar de la variable z a la w
%
%          T/2 + w
%     z = ---------
%          T/2 - w
%
% El resultado es un objeto de Control Systems Toolbox
% con la variable s (correspondiente a un sistema continuo)
%
% Argumentos:
%     gz: sistema de tiempo discreto
%     T : tiempo de muestreo
%

% Ctedra de Control Moderno (Ing. Electricista)
% Fac. de Ingeniera - UNLP

% Curso 2002




[z,p,k]=zpkdata(gz,'v');

nz = length(z);
np = length(p);
if np<nz
   error('El nmero de ceros debe ser menor o igual que nmero de polos')
end,

num = 1;
den = 1;
syms w

for ii=1:np
   den = den*(2/T+w-p(ii)*(2/T-w));
end,
for ii=1:nz
   num = num*(2/T+w-z(ii)*(2/T-w));
end,

num = num*(2/T-w)^(np-nz);

num = k*sym2poly(num);
den = sym2poly(den);

gw = tf(num,den);%,T);