% Ctedra de Control Moderno (Ing. Electricista)
% Fac. de Ingeniera - UNLP

% Curso 2003
% Prctica #5: Problema #3


% planta continua
Gs = zpk([],[0;-0.2],0.2);

% planta discreta
T = 1;   % tiempo de muestreo
Gz = c2d(Gs,T);


% a) lugar de races
rlocus(Gz);

% b) ganancia donde las races son iguales
[n,d] = tfdata(Gz,'v');
[q,r] = polyder(n,d);
ri = roots(q);    % races de dGz/dz=0 (hay dos una negativa y otra positiva)

k1 = 1/abs(evalfr(Gz,ri(1)))
k2 = 1/abs(evalfr(Gz,ri(2)))

% verificacin
zero(1+Gz*k1)
zero(1+Gz*k2)


% c) diseo del controlador
% Especificaciones:
tr = 17;   % tiempo de crecimiento
xi = 0.7;   % relacin de amortiguamiento
beta = atan(sqrt(1-xi^2)/xi);
wd = (pi-beta)/tr;
sg = wd/tan(beta);

pc = [-sg+wd*i;-sg-wd*i];
pd = exp(pc*T);


% diseo:
% valor de Gz en z1
gz1 = evalfr(Gz,pd(1));

% fase de Dz en z1
phiD = 180 - phase(gz1)*180/pi;

% elijo el cero de Dz
zo = 0.7;
phiz = phase(pd(1)-zo)*180/pi;

% el polo de Dz
po = real(pd(1)) - imag(pd(1))/tan(pi/180*(phiz-phiD)); 

% ganancia
Kd = 1/abs(gz1*(pd(1)-zo)/(pd(1)-po));

% Controlador
Dz = zpk(zo,po,Kd,T);


% verificacin
figure
rlocus(Gz*Dz);hold on
plot(real(pd),imag(pd),'LineStyle','none','Marker','square','Color','r');

figure
Tz = Gz*Dz/(1+Gz*Dz);
Ds = d2c(Dz);
Ts = Gs*Ds/(1+Gs*Ds);
step(Tz,Ts);



% investigue la funcin "rltool.m"