% Ctedra de Control Moderno (Ing. Electricista)
% Fac. de Ingeniera - UNLP

% Curso 2002

close all;clear;clc
% Prctica #5: Problema 4

% planta continua
Gs = tf(0.8,[3 1]);


% planta discreta
T  = 0.5;   % tiempo de muestreo
Gz = c2d(Gs,T);

% en el dominio w
Gw = bilineal(Gz,T);


% bode del sistema sin compensar
figure
margin(Gw);    % MF=inf y MG=23.5dB

% Aumentamos la ganancia hasta tener MF=60
% suponiendo que el aporte de fase del polo es de 85
% entonces calculamos la frecuencia donde la fase de Gw es 120
w1 = tan(35*pi/180)/0.25;
gw1 = evalfr(Gw,w1*i);
Kd = 1/abs(gw1);
margin(Kd*Gw);	% se puede corregir un poco Kd para tener MF=60 a w=2.8r/s


% controlador por retraso de fase
wo = 0.28;
wp = 0.1*wo;
Dw = zpk(-wo,-wp,Kd);

% verificacin
Lw = Gw*Dw;
hold on,
margin(Lw);
Tw = Lw/(1+Lw);

% pasaje al dominio z
zo = -(wo - 2/T)/(wo + 2/T);
po = -(wp - 2/T)/(wp + 2/T);
kc = Kd*(wo+2/T)/(wp+2/T);
Dz = zpk(zo,po,kc,T);

% respuesta temporal
figure
Lz = Gz*Dz;
Tz = Lz/(1+Lz);
Ds = d2c(Dz);
Ls = Gs*Ds;
Ts = Ls/(1+Ls);
step(Tz,Ts)